const String Version = "hduino412_LAN";  /*Stand: 2015.09.07 / Verfasser: Eugen Stall
erprobt fuer Arduino Mega 2560 mit Arduino 1.6.5r2
hier ist immer die aktuelle Version:
http://www.stall.biz/project/homeduino-4-0-das-universelle-mess-und-aktormodul-fuer-die-hausautomation
das folgende homeduino-programm sendet messdaten zur ccu (homeduino als webclient) ...
und empfängt ausgabedaten für die homeduino-outputs (homeduino als webserver)
_________________            ________________
|port 8181 server|<---------<| client        |
|                |           |               |
| CCU            |           |     Homeduino | 
|                |           |               |
|          client|>--------->|server port 80 | 
|________________|           |_______________|

/Quellen:Arduino website plus http://arduino.cc/en/Tutorial/WebClient und ...
 http://tushev.org/articles/arduino/item/52-how-it-works-ds18b20-and-arduino und ...  */
//#############################################################################################
//#############################################################################################
//Auswahl der verwendeten Shields: 
#define lcd_display //"tft_display" oder "lcd_display"                         <<user-eingabe<< 
                    //"lcd_display" auch wenn kein display verwendet wird 
#define w5100       //"cc3000"  Wifi-Modul oder "w5100" ethernet shield        <<user-eingabe<< 

byte iobroker[] = { 123, 456, 789, 000 };      //IP von iobroker socketio       <<user-eingabe<< 
byte ccu[] = { 123, 456, 789, 000 };      //IP der CCU                          <<user-eingabe<< 

//MAC-Adresse dieses Homeduinos ,bei mehreren Homeduinos MAC-.Adresse ändern!!:
byte mac[] = { 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC };  //                       <<user-eingabe<<

byte homeduino[] = { 123, 456, 789, 000 }; //IP des Homeduino,wenn DHCP versagt <<user-eingabe<< 

char ap_ssid[] = "ssid"; //SSID WLAN in Anführungszeichen                      <<user-eingabe<< 

char ap_password[] = "password"; //Passwort WLAN in Anführungszeichen          <<user-eingabe<< 

//xyz ist indiv. Bezeichnung dieses homeduino, keine sonderzeichen, öäüß...
const String homeduino_nummer = "001";  //                                     <<user-eingabe<< 
const String hm_systemvariable = "homeduino_" + homeduino_nummer +"_";
//#############################################################################################
//#############################################################################################
//I/O-Kennung: hier wird die Funktion aller verwendbaren IO´s mit einer Kennziffer festgelegt 
//dabei haben alle IO´s die Standardfunktionen plus spez. Sonderfunktionen
//     Standardfunktionen sind:
//     '0' =andere Nutzg; '1' =dig_in; '2' =dig_out; '3' =1wire '4' =DHTxx; '5' =U_Schall 

const byte iomodus_D[80] = { 0,0,
 0, //D2 :      Std-fkt; '15' = IR_Rx??  '6' =ImpCount;         <<user IO-Shield20<< 
 0, //D3 :      Std-fkt; '7' = 433_Rx??  '6' =ImpCount;        <<user IO-Shield20<< 
 0, //D4 :      Std-fkt; '7' = 433_Tx??                <<user IO-Shield20<< 
 0, //D5 :      Std-fkt;                       <<user IO-Shield20<< 
 0, //D6 :      Std-fkt; '9' = buzzer                <<user IO-Shield20<< 
 0, //D7 :      Std-fkt;                       <<user IO-Shield20<< 
 0, //D8 :      Std-fkt;                       <<user IO-Shield20<< 
 0, //D9 :      Std-fkt; '16' = IR_Tx??                <<user IO-Shield20<< 
 20, //D10 :     Std-fkt; '20' = W5100 SS-Pin;
 1,  //D11 :     Std-fkt;  
 1,  //D12 :     Std-fkt;  
 0,  //D13 :     Std-fkt;
 0,  //D14/TX3 : Std-fkt; '0' =ESP8266;                  <<user IO-Shield-Plus<< 
 0,  //D15/RX3 : Std-fkt; '0' =ESP8266;                  <<user IO-Shield-Plus<< 
 0,  //D16/TX2 : Std-fkt; '0' =ESP8266;                  <<user IO-Shield-Plus<< 
 0,  //D17/RX2 : Std-fkt; '0' =ESP8266;                  <<user IO-Shield-Plus<< 
 0,  //D18/TX1 : Std-fkt; '6' =ImpCount;                 <<user IO-Shield-Plus<< 
 0,  //D19/RX1 : Std-fkt; '6' =ImpCount;                               <<user IO-Shield-Plus<< 
 0,  //D20/SDA : Std-fkt; '6' =ImpCount;  '8' =I2C;                    <<user IO-Shield-Plus<< 
 0,  //D21/SCL : Std-fkt; '6' =ImpCount;  '8' =I2C;                    <<user IO-Shield-Plus<< 
 0,  //D22 :     Std-fkt;                        <<user IO-Shield-Plus<< 
 0,  //D23 :     Std-fkt;                        <<user IO-Shield-Plus<< 
 0,  //D24 :     Std-fkt;                                              <<user IO-Shield-Plus<< 
 0,  //D25 :     Std-fkt;                                              <<user IO-Shield-Plus<< 
 0,  //D26 :     Std-fkt;                                              <<user IO-Shield-Plus<< 
 0,  //D27 :     Std-fkt;                                              <<user IO-Shield-Plus<< 
 0,  //D28 :     Std-fkt;                                              <<user IO-Shield-Plus<< 
 0,  //D29 :     Std-fkt;                                              <<user IO-Shield-Plus<< 
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 20, //MISO      '20' =W5100;
 20, //MOSI      '20' =W5100;
 20, //SCK       '20' =W5100;
 0, //SS                     
 0, //D54 A0 :  Std-fkt; '10' =analog; '11' =NTC;           <<IO-Shield-20<< 
 0, //D55 A1 :  Std-fkt; '10' =analog; '11' =NTC;           <<user IO-Shield-20<< 
 0, //D56 A2 :  Std-fkt; '10' =analog; '11' =NTC;           <<user IO-Shield-20<< 
 0, //D57 A3 :  Std-fkt; '10' =analog; '11' =NTC;           <<user IO-Shield-20<< 
 0, //D58 A4 :  Std-fkt; '10' =analog; '11' =NTC;           <<user IO-Shield-20<< 
 0,  //D59 A5 :  Std-fkt; '10' =analog; '11' =NTC;            <<user IO-Shield-20<< 
 0,0,  
 0,  //D62 A8 :  Std-fkt; '10' =analog; '11' =NTC;                    <<user IO-Shield-Plus<< 
 0,  //D63 A9 :  Std-fkt; '10' =analog; '11' =NTC;                    <<user IO-Shield-Plus<< 
 0,  //D64 A10 : Std-fkt; '10' =analog; '11' =NTC;                    <<user IO-Shield-Plus<< 
 0,  //D65 A11 : Std-fkt; '10' =analog; '11' =NTC;                    <<user IO-Shield-Plus<< 
 0,  //D66 A12 : Std-fkt; '10' =analog; '11' =NTC;                    <<user IO-Shield-Plus<< 
 0,  //D67 A13 : Std-fkt; '10' =analog; '11' =NTC;                    <<user IO-Shield-Plus<< 
 0,  //D68 A14 : Std-fkt; '10' =analog; '11' =NTC;                    <<user IO-Shield-Plus<< 
 0,  //D69 A15 : Std-fkt; '10' =analog; '11' =NTC;                    <<user IO-Shield-Plus<< 
 0,  // '0' =andere Nutzg;    '8' =I2C;                               <<user IO-Shield-Plus<< 
 0,  // '0' =andere Nutzg;    '8' =I2C;                               <<user IO-Shield-Plus<< 
 0,  // '0' =andere Nutzg;    '8' =I2C;                               <<user IO-Shield-Plus<< 
 0,  // '0' =andere Nutzg;    '8' =I2C;                               <<user IO-Shield-Plus<< 
 0,  // '0' =andere Nutzg;                                            <<user IO-Shield-Plus<< 
 0,  // '0' =andere Nutzg;                                            <<user IO-Shield-Plus<< 
 0,  // '0' =andere Nutzg;                                            <<user IO-Shield-Plus<< 
 0,  // '0' =andere Nutzg;                                            <<user IO-Shield-Plus<< 
 0,  // '0' =andere Nutzg;                                            <<user IO-Shield-Plus<< 
 0,  // '0' =andere Nutzg;                                            <<user IO-Shield-Plus<< 
}; 
//#############################################################################################
//hier werden Sensoren am I2C-Eingang aktiviert
// const byte iomodus_baro = 0; //'0' =nc; '1' =BMP180,                   <<user IO-Shield-Plus<<
// const byte iomodus_lux = 0; //'0' =nc; '1' =BMP180,                   <<user IO-Shield-Plus<<
const byte iomodus_sht =  1; //'0' =nc; '1' =SHT21,                   <<user IO-Shield-Plus<<
//#############################################################################################
//hier werden die Kennwerte fuer die Impulszaehler festgelegt
volatile unsigned long pulsecounter[6] = 
{ 0, //Zaehlerstand fuer D2 -Impulseingang bei Reset                    <<user IO-Shield20<<
 0, //Zaehlerstand fuer D3 -Impulseingang bei Reset                     <<user IO-Shield20<<
 0, //Zaehlerstand fuer D21-Impulseingang bei Reset                     <<user IO-Shield-Plus<< 
 0, //Zaehlerstand fuer D20-Impulseingang bei Reset                     <<user IO-Shield-Plus<< 
 0, //Zaehlerstand fuer D19-Impulseingang bei Reset                  <<user IO-Shield-Plus<< 
 0 //Zaehlerstand fuer D18-Impulseingang bei Reset                      <<user IO-Shield-Plus<< 
}; 
//hier wird der Teilerfaktor für die Impulszaehler festgelegt
const int pulsedivider[6] = 
{1, //Teilerfaktor D2 :                                                 <<user IO-Shield20<<
 1, //Teilerfaktor D3 :                                                 <<user IO-Shield20<<
 1, //Teilerfaktor D21 :                                                <<user IO-Shield-Plus<<
 1, //Teilerfaktor D20 :                                                <<user IO-Shield-Plus<<
 1, //Teilerfaktor D19 :                                                <<user IO-Shield-Plus<<
 1, //Teilerfaktor D18 :                                                <<user IO-Shield-Plus<<
}; 
//#############################################################################################
//hier werden die Zugangsberechtigungen für den RDM6300 Rfid-Reader und FOBs festgelegt
const byte fob_anzahl = 2;
const String fob[3*fob_anzahl] = {
"2381286","eugen","1",   // '0' = kein Tueroeffner                      <<user IO-Shield-Plus<<
"2381287","eugen","1",   // '1' = Tueroeffner1 D22                      <<user IO-Shield-Plus<<
};
const unsigned long unlock_time1 = 5000; //oeffnungszeit rfid1 in ms    <<user IO-Shield-Plus<<
const unsigned long unlock_time2 = 5000; //oeffnungszeit rfid2 in ms    <<user IO-Shield-Plus<<
const boolean oeffner_polarity = 1;   // '1' normal, '0'  invers        <<user IO-Shield-Plus<<
//#############################################################################################
//#############################################################################################

#include <SPI.h>
#include <Wire.h> 
#include <NewPing.h>   //für Ultraschallsensoren SR04
                       //https://arduino-new-ping.googlecode.com/files/NewPing_v1.5.zip
#include "DHT.h"       //für Temperatursensoren DHT22
                       //https://github.com/adafruit/DHT-sensor-library/archive/master.zip
#include <RCSwitch.h>  // läuft noch nicht!
#include <EEPROM.h>
#include <SHT2x.h>

#if defined (w5100)  //************************************************************************ 
//der folgende Bereich ist die Initialisierung des LAN bei Verwendung des LAN-Shields
#include <Ethernet.h> 
EthernetClient client;
EthernetServer server(80);
#endif  //************************************************************************************* 

const byte zeilenzahl = 6;
int x, x_alt;
byte zeile_pointer[6];
String zeile_data[6] = {"     ","     ","     ","     ","     ","     "};
String display_zeile_alt[6],display_zeile[6];
String taster;

char zeichen,buffer[50];
boolean fob_da =0;
String zeich, fob_hex, fob_dec,Name, lcd_rfid_message, oeffner, Value;
unsigned long fob_zahl,time_rfid3 = 0,time_rfid2 = 0; 
byte zeichen_zahl;

//********************************************************************************************* 
// AS_BH1750 sensor; //Initialize BH1750 Luxmeter library
// float lux;
// long Lux;
int laenge;
// const float ALTITUDE = 299.0; // eigene seehoehe in metern              <<user IO-Shield-Plus<<
// SFE_BMP180 pressure;
char status;
double t_sht21, h_sht21;
boolean reading = false;
String command = String(200);
String shtH_string,shtT_string;
//********************************************************************************************* 
boolean last_digital_value_D[80];
float last_value_D[80],last_IR_value,last_RF_value;
unsigned long next_Time[80];  
double last_shtH_value,last_shtT_value;
boolean complete_loop =1; // wenn 1, dann einmal komplett durchlaufen
String befehl,sub_command = String(20),parameter = String(20),header = String(20);
String befehl2,sub_command2 = String(20),parameter2 = String(20),header2 = String(20);
int param,port_pin;
boolean port_data;
boolean value;
String I;
int analogwert;
//********************************************************************************************* 
float tempNTC;
const float B_wert = 3950; //aus dem Datenblatt des NTC //<<user-eingabe<<
const float Tn = 298.15; //25°Celsius in °Kelvin 
const float Rv = 10000; //Vorwiderstand
const float Rn = 10000; //NTC-Widerstand bei 25°C
float Rt,temp_tur,humidity;
 
const float delta_onewire = 0.2; //Deltas für Sendeauslösung 
const float delta_DHT = 0.1; //in °C 
const float delta_us = 3.0; // in cm
const float delta_analog = 2.0; // in inkrement
const float delta_ntc = 0.5; //in °C
const float delta_counter = 5; //in counter inkrement
const float delta_shtH = 0.2; //in %
const float delta_shtT = 0.1; //in °C

long duration, cm; //variable für Ultraschallsensor
unsigned long time_sr04;
 
unsigned long next_full_loop = 0;
unsigned long delta_time = 3600000; // jede Stunde werden alle Inputs aktualisiert
unsigned long delta_tx = 500; //in ms, minimaler Abstand der Telegramme an die CCU
unsigned long next_tx = 0, time_wait = 0; 

int rf_key;
String rfkey;
RCSwitch mySwitch = RCSwitch();

unsigned zaehlwert;
unsigned last_zaehlwert[6] = {0,0,0,0,0,0};
//#############################################################################################
//#############################################################################################
void setup() 
{Serial.begin(9600);
Wire.begin();

#if defined (w5100)  //************************************************************************* 
 if ((pulsedivider[5] > 0) && (iomodus_D[18] == 6))  //interrupt reserviert fuer cc3000
   {pinMode(18, INPUT_PULLUP); attachInterrupt(5, ISR_5, FALLING);}
#endif  //*************************************************************************************

for(int i=0; i<zeilenzahl; i++)
   {zeile_pointer[i] = EEPROM.read(i);  //anzeige-pointer aus eeprom holen
    if (zeile_pointer[i] >79) {zeile_pointer[i] = 0;}  //wenn eeprom erstes mal benutzt wird
   } 

#if defined (w5100)  //************************************************************************
//hier folgt die LAN Initialisierung 
char myIpString[24];
 if (Ethernet.begin(mac) == 0) // start the Ethernet connection:
   {Serial.println("Failed to configure Ethernet using DHCP"); Ethernet.begin(mac, homeduino);}
    delay(1000);// give the Ethernet shield a second to initialize:
    Serial.println("connecting..."); // if you get a connection, report back via serial:
 if (client.connect(ccu, 8181)) {}
   else {Serial.println("connection to ccu failed");} // if you didn't get a connection to the server:
 client.stop();
 if (client.connect(iobroker, 8082)) {}
 else {Serial.println("connection to ccu failed");} // if you didn't get a connection to the server:
 client.stop();
 IPAddress myIp = Ethernet.localIP();
 sprintf(myIpString, "%d.%d.%d.%d", myIp[0], myIp[1], myIp[2], myIp[3]); 
 I = myIpString;
 befehl = "GET /xy.exe?antwort=dom.GetObject('"+hm_systemvariable+"IP"+"').State('"+ I + "')";
 set_sysvar();
 befehl2 = "GET /set/javascript.0.Technikraum.Homeduino."+hm_systemvariable+"IP"+"?value="+I;
 set_sysvar2();
 server.begin();
#endif  //*************************************************************************************
for (int i = 0; i < 80; i++) {next_Time[i]=0;} //
 //delay(2000);
}
//#############################################################################################
//#############################################################################################
void loop() 
{complete_loop = 0;
 if (millis() > next_full_loop) //mindestens jede Stunde eine komplette Aktualisierung
   {complete_loop = 1; next_full_loop = millis() + delta_time; 
    if (next_full_loop < millis()) {complete_loop = 0;} //wichtig wegen Zahlensprung 
                                                        //von millis() alle 50 Tage
   } 
//*********************************************************************************************
 for (int i = 2; i < 70; i++) //behandlung aller Ports D2 bis D69 
 {while ((iomodus_D[i] == 0) || (iomodus_D[i] >29 )) {i++;}  // unbenutzte pins überspringen
  datenempfang(); //nach jeder Messung auf Datenempfang schalten
 //******************************************************************************************** 
 if (iomodus_D[i] == 1) //behandlung digitaleingänge 
   {if (millis() > next_Time[i])
      {next_Time[i] = next_Time[i] +1000;  //digitaleingänge nicht häufiger als alle 1000ms abfragen
       pinMode(i, INPUT_PULLUP); 
       digitalWrite(i, HIGH);
       value =digitalRead(i);
       for (int m=0; m < zeilenzahl; m++)
         {if (zeile_pointer[m] == i) 
            {if (value ==0) {zeile_data[m] = "LOW";} else {zeile_data[m] = "HIGH";}}}
       if ((!value == last_digital_value_D[i]) || complete_loop) 
         {I = String(i);
          befehl="GET /xy.exe?antwort=dom.GetObject('"+hm_systemvariable+"D"+I+"').State("+value+")";
          set_sysvar();
          befehl2="GET /set/javascript.0.Technikraum.Homeduino."+hm_systemvariable+"D"+I+"?value="+value;
          set_sysvar2();
          last_digital_value_D[i] = value;
         }
      } 
   }
//********************************************************************************************* 
 if (iomodus_D[i] == 4) //behandlung DHT temperatur- und feuchtesensoren
   {if (millis() > next_Time[i])
      {next_Time[i] = next_Time[i] +30000;  //DHT nicht häufiger als alle 30s abfragen 
       DHT dht(i, DHT22); //je nach verwendetem sensor "DHT11", "DHT22" (AM2302),"DHT 21" (AM2301)
       dht.begin();
       time_wait = millis() +2000;                       //wahrend der 2s wartezeit, daten empfangen
       while (millis() < time_wait) {datenempfang();} //und display weiter bedienen 
       humidity = dht.readHumidity(); // Read temperature as Celsius
       temp_tur = dht.readTemperature(); 
       if (isnan(humidity) || isnan(temp_tur) ) // Check if any reads failed and 
         {//Serial.println("Failed to read from DHT sensor!");
          temp_tur = -1000;
         }
       for (int m=0; m < zeilenzahl; m++)
         {if (zeile_pointer[m] == i) {zeile_data[m] = String(temp_tur,1);}
         }
         if ((temp_tur > (last_value_D[i] + delta_DHT))|| (temp_tur < (last_value_D[i] - delta_DHT)) || complete_loop)
         {I = String(i);
          befehl="GET /xy.exe?antwort=dom.GetObject('"+hm_systemvariable+"D"+I+"').State("+temp_tur+")";
          set_sysvar();
          befehl="GET /xy.exe?antwort=dom.GetObject('"+hm_systemvariable+"D"+I+"_1').State("+humidity+")";
          set_sysvar();
          befehl2 = "GET /set/javascript.0.Technikraum.Homeduino."+hm_systemvariable+"D"+I+"?value="+temp_tur;
          set_sysvar2();
          befehl2 = "GET /set/javascript.0.Technikraum.Homeduino."+hm_systemvariable+"D"+I+"_1"+"?value="+humidity;
          set_sysvar2();
          last_value_D[i] = temp_tur;
         }
        }
   } 
//********************************************************************************************* 
 if (iomodus_D[i] == 10) //behandlung analogeingänge 
   {if (millis() > next_Time[i])
      {next_Time[i] = next_Time[i] +1000;  //analogeingänge nicht häufiger als alle 1000ms abfragen 
       analogwert =analogRead(i);
       for (int m=0; m < zeilenzahl; m++)
         {if (zeile_pointer[m] == i) {zeile_data[m] = String(analogwert);}}
       if ((analogwert > (last_value_D[i] + delta_analog)) 
                || (analogwert < (last_value_D[i] - delta_analog)) || complete_loop) 
         {I = String(i);
          befehl="GET /xy.exe?antwort=dom.GetObject('"+hm_systemvariable+"D"+I+"').State("+analogwert+")";
          set_sysvar();
          befehl2 = "GET /set/javascript.0.Technikraum.Homeduino."+hm_systemvariable+"D"+I+"?value="+analogwert;
          set_sysvar2();
          last_value_D[i] = analogwert;
         }
      }
   } 
//*********************************************************************************************
 if (iomodus_D[i] == 11) //behandlung NTC 
   {if (millis() > next_Time[i])
      {next_Time[i] = next_Time[i] +10000;  //NTC-eingänge nicht häufiger als alle 10s abfragen
       Rt = Rv/((1024.0/analogRead(i))- 1.0);
       tempNTC = (B_wert * Tn / ( B_wert + (Tn * log(Rt/Rn)))) -Tn +25.0 ;
       for (int m=0; m < zeilenzahl; m++)
         {if (zeile_pointer[m] == i) {zeile_data[m] = String(tempNTC,1);}}
          if ((tempNTC > (last_value_D[i] + delta_ntc)) || (tempNTC < (last_value_D[i] - delta_ntc)) || complete_loop) 
            {I = String(i);
             befehl="GET /xy.exe?antwort=dom.GetObject('"+hm_systemvariable+"D"+I+"').State("+tempNTC+")";
             set_sysvar();
             befehl2 = "GET /set/javascript.0.Technikraum.Homeduino."+hm_systemvariable+"D"+I+"?value="+tempNTC;
             set_sysvar2();
             last_value_D[i] = tempNTC;
            } 
      }
   }     

//behandlung sht21 an SCL pin21 und SDA pin 20 ***********************************
 if ((iomodus_D[i] == 8)&&(i == 20))
   {i++;  // da I2C Bus 2 eingaenge belegt
    if (iomodus_sht ==1)
      {if (millis() > next_Time[72])
         {next_Time[72] = next_Time[72] +10000;  //luxmeter nicht haeufiger als alle 5s abfragen 
          h_sht21 = ( SHT2x.GetHumidity() ); // ggf ( ) nicht setzten.
          t_sht21 = ( SHT2x.GetTemperature() ); // ggf ( ) nicht setzten.
          if ((h_sht21 > (last_shtH_value + delta_shtH)) || (h_sht21 < (last_shtH_value - delta_shtH)) || complete_loop)
              {befehl="GET /xy.exe?antwort=dom.GetObject('"+hm_systemvariable+"SHT-Feuchte"+"').State("+h_sht21+")";
              set_sysvar();
              befehl2="GET /set/javascript.0.Technikraum.Homeduino."+hm_systemvariable+"SHT_Feuchte"+"?value="+h_sht21;
              set_sysvar2();
              last_shtH_value = h_sht21;
              last_value_D[72] = h_sht21;
              }
          if ((t_sht21 > (last_shtT_value + delta_shtT)) || (t_sht21 < (last_shtT_value - delta_shtT)) || complete_loop)
              {befehl="GET /xy.exe?antwort=dom.GetObject('"+hm_systemvariable+"SHT-Temp"+"').State("+t_sht21+")";
              set_sysvar();
              befehl2="GET /set/javascript.0.Technikraum.Homeduino."+hm_systemvariable+"SHT_Temp"+"?value="+t_sht21;
              set_sysvar2();
              last_shtT_value = t_sht21;
              last_value_D[73] = t_sht21;
              }
          } 
      }
  }
//**************************   ende loop  *****************************************************
 }
} 
//#############################################################################################
//#############################################################################################
//#############################  Unterprogramme   #############################################

void datenempfang() //Unterprogramm datenempfang: daten von ccu an homeduino senden
{command = ""; 

#if defined (w5100)  //************************************************************************
 EthernetClient client = server.available();   //mit W5100
#endif  //************************************************************************************* 

 if (client) // an http request ends with a blank line
   {boolean currentLineIsBlank = true;
    while (client.connected())
      {if (client.available()) 
         {char c = client.read();
          if (reading && c == ' ') reading =false;
          if (c == '?') reading = true; // beginn der Befehlssequenz 
          if (reading) 
            {if (command.length() < 100) //read char by char HTTP request
               {command = command + c; } //store characters to string
            } 
          if (c == '\n' && currentLineIsBlank) break;
          if (c == '\n') {currentLineIsBlank = true;} 
            else if (c != '\r') { currentLineIsBlank = false;}
         } 
       } 
     client.println(command);
     delay(1); 
     client.stop();
//*********************************************************************************************
    if (command.length() > 2) //behandlung Datenempfang von ccu: port auf 0/1 setzen 
      {Serial.println(command); //empfangenen befehl ausgeben
       client.print(command); //befehl dann dekodieren 
       int colonPosition = command.indexOf(':');
       sub_command = command.substring(2,colonPosition); //portpin erkennen
       Serial.print("D" + sub_command + " :");
       port_pin = sub_command.toInt();
       command = command.substring((colonPosition+1)); //Rest-command bilden
       if (((iomodus_D[port_pin] == 2)||(iomodus_D[port_pin] == 12)) && (command == "0")) 
         {for (int m=0; m < zeilenzahl; m++)
            {if (zeile_pointer[m] == port_pin) {zeile_data[m] = " LOW";}
            }
          pinMode(port_pin, OUTPUT); digitalWrite(port_pin, LOW); Serial.println(command);
         }
       if ((iomodus_D[port_pin] == 2) && (command == "1")) 
         {for (int m=0; m < zeilenzahl; m++)
            {if (zeile_pointer[m] == port_pin) {zeile_data[m] = " HIGH";}
            }
          pinMode(port_pin, OUTPUT); digitalWrite(port_pin, HIGH); Serial.println(command);}
          if ((iomodus_D[port_pin] == 7) && (port_pin ==4)) 
            {rf_send(command); Serial.println(command);} 
          if ((iomodus_D[port_pin] == 5) && (port_pin ==9)) 
            {ir_send(command); Serial.println(command);} 
      }
  } 
} 
//*********************************************************************************************
void set_sysvar() // subroutine HTTP request an CCU absetzen:
{//while (millis() < next_tx) {} //warten bis time > next_tx oder timeout
 next_tx = millis() +delta_tx;
 if (client.connect(ccu, 8181)) 
   {Serial.println(befehl);
    client.println(befehl);
    client.println();
    client.stop();
   } else {Serial.println("connection to ccu2 failed");}
}
void set_sysvar2() // subroutine HTTP request an IoBroker absetzen:
{//while (millis() < next_tx) {} //warten bis time > next_tx oder timeout
 next_tx = millis() +delta_tx;
 if (client.connect(iobroker, 8082)) 
   {Serial.println(befehl2);
    client.println(befehl2);
    client.println();
    client.stop();
   } else {Serial.println("connection to iobroker failed");}
}
//*********************************************************************************************
void rf_send(String rf_command) // subroutine rf telegramm senden
{
}
//*********************************************************************************************
void ir_send(String ir_command) // subroutine ir telegramm senden
{
}
//*********************************************************************************************
//hier sind die interrupt-service-routinen fuer die impulszaehler  //**************************
void ISR_0() //Interrupt an D2
{pulsecounter[0]++;}
void ISR_1() //Interrupt an D3
{pulsecounter[1]++;}
void ISR_2() //Interrupt an D21
{pulsecounter[2]++;}
void ISR_3() //Interrupt an D20
{pulsecounter[3]++;}
void ISR_4() //Interrupt an D19
{pulsecounter[4]++;}
void ISR_5() //Interrupt an D18 
{pulsecounter[5]++;}
//*********************************************************************************************
//Unterprogramm:  Converting from Hex (unsigned long) to Decimal: *****************************
//Quelle https://github.com/benrugg/Arduino-Hex-Decimal-Conversion/blob/master/hex_dec.ino
unsigned long hexToDec(String hexString) 
{unsigned long decValue = 0;
 int nextInt;
 for (int k = 0; k < hexString.length(); k++) 
   {nextInt = int(hexString.charAt(k));
    if (nextInt >= 48 && nextInt <= 57) nextInt = map(nextInt, 48, 57, 0, 9);
    if (nextInt >= 65 && nextInt <= 70) nextInt = map(nextInt, 65, 70, 10, 15);
    if (nextInt >= 97 && nextInt <= 102) nextInt = map(nextInt, 97, 102, 10, 15);
    nextInt = constrain(nextInt, 0, 15);
    decValue = (decValue * 16) + nextInt;
  }
 return decValue;
}
